//#define SAVE_SCREEN							// this directive forces saving/restoring the screen

// produce all types of files
#define USE_TI89								// compile for 89
#define USE_TI92PLUS							// compile for 92+
#define USE_V200								// compile for voyage 200

//#include "extgraph.h"
#include <stdio.h>								// standard ANSI C input/output support
#include <kbd.h>								// keyboard handling support, needed for ngetchx
#include <tigcclib.h>							// include all headers

												// Sprite16 (x, y, height, name, GrayGetPlane (LIGHT_PLANE), SPRT_XOR);
												// sprite for a ball (grayscale for smooth edges)
unsigned char lball[8] = {						// light layer
	0x3C,0x3C,0xFF,0xFF,0xFF,0xFF,0x3C,0x3C	
};
unsigned char dball[8] = {						// dark layer
	0x18,0x7E,0x7E,0xFF,0xFF,0x7E,0x7E,0x18
};

void _main(void)								// main entrie point of program
{												// contents withen brackets
randomize();									// seed the random generator
// double buffering for flickerless results
char *lightBuff = malloc(LCD_SIZE);				// define light buffer
char *darkBuff = malloc(LCD_SIZE);				// define dark buffer

        memset(lightBuff,0,LCD_SIZE);			// clear the light buffer //
        memset(darkBuff,0,LCD_SIZE);			// clear the dark buffer //
		
int total_balls = 1000;							// the total amount of balls allowed (i made it only this that you have to change if you really want more balls)

int xballs[total_balls];						// x cords of the balls
int yballs[total_balls];						// y cords of the balls
int horz[total_balls];							// horizontal speed
int vert[total_balls];							// vertical speed
int loop = 0;									// for the for loops
int balls = 1;									// amount of balls on the screen

for (loop = 0; loop < total_balls; loop++)		// define all the variables to be random
	{
	xballs[loop]	= random(135)+4;			// xball array
	yballs[loop]	= random(75)+2;				// yball array
	horz[loop]		= random(4)-2;				// horz array
	vert[loop]		= random(4)-2;				// vert array
	}

// i'm doing pretty much the same thing as #define SAVE_SCREEN but i want to have a message at the end
void *scrBuf=malloc(LCD_SIZE);					// define the homescreen saving variable
LCD_save(scrBuf);								// save the screen to it

clrscr();										//do i have to explain? ...ok... this clears the screen

INT_HANDLER save_int_1;							// save before redirection
save_int_1 = GetIntVec (AUTO_INT_1);			// tell what it is
SetIntVec (AUTO_INT_1, DUMMY_HANDLER);			// redirect auto-int 1 to "nothing"
INT_HANDLER save_int_5;							// save before redirection
save_int_5 = GetIntVec (AUTO_INT_5);			// tell what it is
SetIntVec (AUTO_INT_5, DUMMY_HANDLER);			// redirect auto-int 5 to "nothing"

if (!GrayOn())									// turn gray on
{												// some error handling...
SetIntVec (AUTO_INT_1, save_int_1);				// restore interupt 1
SetIntVec (AUTO_INT_1, save_int_5);				// restore interupt 5
LCD_restore(scrBuf);							// restor homescreen
free(scrBuf);									// free alocation
ST_helpMsg("GRAY FAILED!!!!!!!");				// disp "GRAY FAILED!!!!!!!" in the status bar
return;											// quit program
}												// end of error handling

while (!_keytest(RR_ESC))						// if the opperator press esc, quit
	{											// contents of the main loop withen brackets
	memset(lightBuff,0,LCD_SIZE);				// clear gray buffers
	memset(darkBuff,0,LCD_SIZE);				// clear gray buffers
	for (loop = 0; loop < balls; loop++)		// for loop that goes through all of the arrays for position and updates
		{
		if (xballs[loop] <= 2 || xballs[loop] >= 150)	horz[loop] = -horz[loop]; // negate the speeds if they hit the edge of the screen
		if (yballs[loop] <= 2 || yballs[loop] >= 90)	vert[loop] = -vert[loop]; // top and bottem
					
		xballs[loop] += horz[loop];				// add the horizontal speeds
		yballs[loop] += vert[loop];				// add the vertical speeds
						
		Sprite8 (xballs[loop], yballs[loop], 8, lball, lightBuff, SPRT_OR); // copy the sprites to the buffers
		Sprite8 (xballs[loop], yballs[loop], 8, dball, darkBuff, SPRT_OR);	// dark
		}
	memcpy(GetPlane(LIGHT_PLANE), lightBuff, LCD_SIZE); // Copy the light buffer to the screen
	memcpy(GetPlane(DARK_PLANE), darkBuff, LCD_SIZE);	// Copy the dark buffer to the screen
	if (_keytest(RR_PLUS))						// if the plus button is pressed..
		{
		OSContrastUp();							// turn the contrast up
		for (loop = 0; loop < 10000; loop++){}	// delay
		}
	if (_keytest(RR_MINUS))						// if the minus button is pressed..
		{
		OSContrastDn();							// turn the contrast down
		for (loop = 0; loop < 10000; loop++){}	// delay
		}
	if (_keytest(RR_UP) && balls < total_balls)	// up pressed..
		{
		balls++;								// add to displayed balls
		for (loop = 0; loop < 20000; loop++){}	// delay
		}
	if (_keytest(RR_DOWN) && balls > 1)			// down pressed..
		{
		balls--;								// subtract from displayed balls
		for (loop = 0; loop < 20000; loop++){}	// delay
		}
	if (_keytest(RR_RIGHT) && balls < total_balls) // inc by 1 with no delay
		balls++;								// add to displayed balls
	if (_keytest(RR_LEFT) && balls > 1)			// sub by 1 with no delay
		balls--;
	if (_keytest(RR_F5) && balls < (total_balls - 5)) // inc by 5
		balls += 5;								// add 5..
	if (_keytest(RR_F4) && balls > 5)			// sub by 5
		balls -= 5;								// sun 5
	
	if (_keytest(RR_F1))						// if key f1
		{
		// F_4x6, F_6x8, and F_8x10				// just some things to remember
		SetPlane (LIGHT_PLANE);					// set the light plane to be written to
		ScrRectFill (&(SCR_RECT){{0, 40, 159, 60}}, ScrRect, 1); // fill the cords with light gray
		SetPlane (DARK_PLANE);					// set the dark plane to be written to
		ScrRectFill (&(SCR_RECT){{0, 40, 159, 60}}, ScrRect, 0); // clear the cords with dark gray
		FontSetSys (F_8x10);					// set font size
		MoveTo(60,45);							// move the curser
		printf ("%d",balls);					// display the amount of displayed balls
		while (!_keytest(RR_ENTER)){}			// wait for enter to be pressed
		}
	}											// end of main loop

GrayOff();										// turn grayscale off
SetIntVec (AUTO_INT_1, save_int_1);				// restore interupt 1
SetIntVec (AUTO_INT_5, save_int_5);				// restore interupt 5
LCD_restore(scrBuf);							// restore homescreen
free(scrBuf);									// free alocation
free(lightBuff);								// free alocation
free(darkBuff);									// free alocation
ST_helpMsg("By Alex Clink");					// disp "By Alex Clink" in the status bar
}												// end of main and program
/* no comment */

